/*
	[WS_MailClass.cpp]
	Author : Xing Yanhuan
*/


#include "WS_MailClass.h"



void Mail::setFrom(const std::string& from){
	from_ = from;
}

void Mail::setTo(const std::string& to){
	to_ = to;
}

void Mail::setSubject(const std::string& subject){
	subject_ = subject;
}

void Mail::setBody(const std::string& body){
	body_ = body;
}

std::string Mail::getFrom() const{
	return from_;
}

std::string Mail::getTo() const{
	return to_;
}

std::string Mail::getSubject() const{
	return subject_;
}

std::string Mail::getBody() const{
	return body_;
}






MailTransporter::MailTransporter(){
	WSADATA wsaData;

	// pWinSockAPI̊Jn
		if(WSAStartup(MAKEWORD(1, 1), &wsaData) != 0){
		fWSAStartup = false;
	}else{
		fWSAStartup = true;
	}
}
MailTransporter::~MailTransporter(){
	// pWinSockAPȈI
	WSACleanup();
}


// SMTPT[o[ݒ肷B
void MailTransporter::setSmtp(const std::string& serverName){
	smtp_ = serverName;
}
// Pop3T[o[ƁAFIDpX[hݒ肷B
void MailTransporter::setPop3(const std::string& serverName, const std::string& serverAccount, const std::string& serverPass){
	pop3_ = serverName;
	pass_ = serverPass;
	accu_ = serverAccount;
}


// [𑗐MB
bool MailTransporter::send(const Mail& mail){
	// WinSockAPI̊JnIĂ邱ƂmFB
	if( false==fWSAStartup ){
		strErrMsg = "WSAStartup() failed";
		return false;
	}

	// PopBeforeSMTPŔF؂݂B
	if( false==PopBeforeSMTP() ){
		return false;
	}

	// SMTP̃zXgT[o[֐ڑB
	LPHOSTENT lpHost = gethostbyname(smtp_.c_str());
	if(lpHost == NULL){
		strErrMsg = "SMTP server name error";
		return false;
	}

	// \Pbg쐬B
	SOCKET s = socket(PF_INET, SOCK_STREAM, 0);
		if(s == INVALID_SOCKET){
		strErrMsg = "socket() error";
		return false;
	}

	// T[rX񂩂|[gԍ擾
	// IPPORT_SMTP = 25 // 萔
	LPSERVENT lpServ = getservbyname("mail", NULL);
	int port = (lpServ == NULL) ? htons(IPPORT_SMTP) : lpServ->s_port;

	// \PbgڑB
	char pszRcvBuf[1024];
	SOCKADDR_IN sockAddr;
	sockAddr.sin_family = AF_INET;
	sockAddr.sin_port = port;
	sockAddr.sin_addr = *((LPIN_ADDR)*lpHost->h_addr_list);
	if(connect(s, (PSOCKADDR)&sockAddr, sizeof(SOCKADDR_IN))){
		// G[́A|[g587(Message Submission)ɕύXăgCB
		port = htons( 587 );
		sockAddr.sin_port = port;
		if(connect(s, (PSOCKADDR)&sockAddr, sizeof(SOCKADDR_IN))){
			strErrMsg = "connect() error";
			return false;
		}
	}
	recvMailMsg(s, pszRcvBuf, 1024);
	if( 0!=memcmp( "220", pszRcvBuf, 3 ) ){
		strErrMsg = pszRcvBuf;
		return false;
	}

	// SMTPT[o[Ƃ̉bJnB
	std::string strSendBuf; 
	sprintf( pszRcvBuf, "HELO %s \r\n", smtp_.c_str() );
	strSendBuf = pszRcvBuf;
	sendMailMsg(s, strSendBuf);
	recvMailMsg(s, pszRcvBuf, 1024);
	if( 0!=memcmp( "250", pszRcvBuf, 3 ) ){
		strErrMsg = pszRcvBuf;
		return false;
	}

	// MAhXb
	sprintf( pszRcvBuf, "MAIL FROM:<%s>\r\n", mail.getFrom().c_str() );
	strSendBuf = pszRcvBuf;
	sendMailMsg(s, strSendBuf);
	recvMailMsg(s, pszRcvBuf, 1024);
	if( 0!=memcmp( "250", pszRcvBuf, 3 ) ){
		strErrMsg = pszRcvBuf;
		return false;
	}

	// MAhXb
	sprintf( pszRcvBuf, "RCPT TO:<%s>\r\n", mail.getTo().c_str());
	strSendBuf = pszRcvBuf;
	sendMailMsg(s, strSendBuf);
	recvMailMsg(s, pszRcvBuf, 1024);
	if( 0!=memcmp( "250", pszRcvBuf, 3 ) ){
		strErrMsg = pszRcvBuf;
		return false;
	}

	// [{(^Cg܂)𑗂n߂邱Ƃb
	sendMailMsg(s, "DATA\r\n");
	recvMailMsg(s, pszRcvBuf, 1024);
	if( 0!=memcmp( "354", pszRcvBuf, 3 ) ){
		strErrMsg = pszRcvBuf;
		return false;
	}
	// [^Cg
	sprintf( pszRcvBuf, "Subject: %s \r\n", mail.getSubject().c_str());
	strSendBuf = pszRcvBuf;
	sendMailMsg(s, strSendBuf);
	// LR[hݒ
	sendMailMsg(s, "MIME-Version: 1.0\r\n" );
	sendMailMsg(s, "Content-Type: text/plain;\r\n" );
	sendMailMsg(s, "      charset=\"shift_jis\"\r\n" );
	// wb_Iʒm
	sendMailMsg(s, "\r\n");	
	// [{𑗐MJn
	strSendBuf = mail.getBody();
	strSendBuf = strSendBuf + "\r\n";
	sendMailMsg(s, strSendBuf);
	sendMailMsg(s, ".\r\n");
	recvMailMsg(s, pszRcvBuf, 1024);
	if( 0!=memcmp( "250", pszRcvBuf, 3 ) ){
		strErrMsg = pszRcvBuf;
		return false;
	}

	// [M|b
	sendMailMsg(s, "QUIT\r\n");
	recvMailMsg(s, pszRcvBuf, 1024);

	// \PbgؒfB
	closesocket(s);
return true;
}


// G[̃bZ[WԂB
char* MailTransporter::GetErrorMsg(){ return (char*)strErrMsg.c_str(); }

void MailTransporter::sendMailMsg(SOCKET s, const std::string& text){
	::send(s, text.c_str(), text.length(), 0); 
	// std::cout << "[send]" << text << "\r\n";
}

void MailTransporter::recvMailMsg(SOCKET s, char* pszRcvBuf, int nBufSize ){
	memset(pszRcvBuf, '\0', nBufSize );
	::recv(s, pszRcvBuf, nBufSize-1, 0);
	// std::cout << "[recv]" << pszRcvBuf << "\r\n";
}

bool MailTransporter::PopBeforeSMTP(){
	// WinSockAPI̊JnIĂ邱ƂmFB
	if( false==fWSAStartup ){
		strErrMsg = "WSAStartup() failed";
		return false;
	}

	// Pop3̃zXgT[o[֐ڑB
	LPHOSTENT lpHost = gethostbyname(pop3_.c_str());
	if(lpHost == NULL){
		strErrMsg = "Pop3 server name error";
		return false;
	}

	// \Pbg쐬B
	SOCKET s = socket(PF_INET, SOCK_STREAM, 0);
	if(s == INVALID_SOCKET){
		strErrMsg = "Pop3 socket() error";
		return false;
	}

	// \PbgڑB
	// |[g110Œ
	char pszRcvBuf[1024];
	SOCKADDR_IN sockAddr;
	sockAddr.sin_family = AF_INET;
	sockAddr.sin_port = htons(110);
	sockAddr.sin_addr = *((LPIN_ADDR)*lpHost->h_addr_list);
	if(connect(s, (PSOCKADDR)&sockAddr, sizeof(SOCKADDR_IN))){
		strErrMsg = "Pop3 connect() error";
		return false;
	}
	recvMailMsg(s, pszRcvBuf, 1024);
	if( 0!=memcmp( "+OK", pszRcvBuf, 3 ) ){
		strErrMsg = "Failed to open pop3 server.";
		return false;
	}

	// Pop3F؂݂B
	char pszSendBuf[1024]; 
	sprintf(pszSendBuf, "USER %s\r\n", accu_.c_str() );
	sendMailMsg(s, pszSendBuf);
	recvMailMsg(s, pszRcvBuf, 1024);
	if( 0!=memcmp( "+OK", pszRcvBuf, 3 ) ){
		strErrMsg = "User Name is not vailed.";
		return false;
	}
	sprintf(pszSendBuf, "PASS %s\r\n", pass_.c_str() );
	sendMailMsg(s, pszSendBuf);
	recvMailMsg(s, pszRcvBuf, 1024);
	if( 0!=memcmp( "+OK", pszRcvBuf, 3 ) ){
		strErrMsg = "Password is wrong.";
		return false;
	}

	// IB
	sprintf(pszSendBuf, "QUIT\r\n" );
	sendMailMsg(s, pszSendBuf);
	recvMailMsg(s, pszRcvBuf, 1024);

	// \PbgؒfB		
	closesocket(s);
	return true;
}


